﻿Public Class frm_Main
    Dim RXByte As Byte

    Public Structure PortBlitzValues
        Dim Level As Integer
        Dim PWM_Level As Integer
        Dim TDate As String
        Dim TTime As String
        Dim DeltaTime As String
    End Structure

    Shared Values() As PortBlitzValues

    Shared Array(-1) As Byte

    Shared LastLogTime As UInteger
    Shared CurrentLogTime As UInteger

    Shared LastLevel As String = " "
    Shared LastDate As String = " "
    Shared LastTime As String = " "

    Private Sub frm_Main_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        SerialPort.Dispose()
        SerialPort.Close()
    End Sub

    Private Sub frm_Main_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Me.Text = Me.Text & " " & My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & "." & My.Application.Info.Version.Build
        Me.Text = Me.Text & " - " & My.Application.Info.Copyright & "  www.ramser-elektro.at"
        GetAvailableComPorts()
    End Sub

    Sub GetAvailableComPorts()
        SerialPort.Dispose()
        SerialPort.Close()
        btn_OpenPort.Text = "Open Port"
        cob_AvailablePorts.Items.Clear()
        For Each sp As String In My.Computer.Ports.SerialPortNames
            cob_AvailablePorts.Items.Add(sp)
        Next
        Try
            cob_AvailablePorts.SelectedIndex = 0
        Catch ex As Exception

        End Try
    End Sub

    Private Sub btn_RefreshAvailablePorts_Click(sender As System.Object, e As System.EventArgs) Handles btn_RefreshAvailablePorts.Click
        GetAvailableComPorts()
    End Sub

    Private Sub btn_OpenPort_Click(sender As System.Object, e As System.EventArgs) Handles btn_OpenPort.Click
        If btn_OpenPort.Text = "Open Port" Then
            SerialPort.PortName = cob_AvailablePorts.SelectedItem
            Try
                SerialPort.Open()
                btn_OpenPort.Text = "Close Port"
                ReDim Array(-1)
                ReDim Values(-1)
                lst_RecordedValues.Items.Clear()
            Catch ex As Exception
                MsgBox(ex.ToString)
            End Try
        Else
            SerialPort.Close()
            btn_OpenPort.Text = "Open Port"
        End If

    End Sub

    Private Sub SerialPort_DataReceived(sender As Object, e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort.DataReceived
        If InvokeRequired Then
            Me.Invoke(Sub() AddToArray())
        Else
            AddToArray()
        End If
    End Sub

    Sub AddToArray()
        Dim BytesToRead As Integer = SerialPort.BytesToRead
        Dim Buffer(BytesToRead - 1) As Byte
        SerialPort.Read(Buffer, 0, BytesToRead)
        For i = 0 To UBound(Buffer)
            ReDim Preserve Array(UBound(Array) + 1)
            Array(UBound(Array)) = Buffer(i)
        Next
startagain:
        If Array.Count >= 4 Then
            If Array(0) = 160 Then
                ExpandArray(Values)
                Values(UBound(Values)).Level = (Array(1) * 256) + (Array(2))
                LastLevel = Values(UBound(Values)).Level
                Values(UBound(Values)).PWM_Level = Array(3)
                Values(UBound(Values)).TDate = Date.Now.Year & "." & CorrectTo00(Date.Now.Month) & "." & CorrectTo00(Date.Now.Day)
                LastDate = Values(UBound(Values)).TDate
                Values(UBound(Values)).TTime = CorrectTo00(Date.Now.Hour) & ":" & CorrectTo00(Date.Now.Minute) & ":" & CorrectTo00(Date.Now.Second)
                LastTime = Values(UBound(Values)).TTime
                CurrentLogTime = Date.Now.Hour * 3600 + Date.Now.Minute * 60 + Date.Now.Second
                Values(UBound(Values)).DeltaTime = CurrentLogTime - LastLogTime
                LastLogTime = CurrentLogTime
                RemoveAt(Array, 0)
                RemoveAt(Array, 0)
                RemoveAt(Array, 0)
                RemoveAt(Array, 0)
                GoTo startagain
            Else
                RemoveAt(Array, 0)
                GoTo startagain
            End If
        End If

        If Not IsNothing(Values) Then
            lst_RecordedValues.BeginUpdate()
            lst_RecordedValues.Items.Clear()
            For i = 0 To UBound(Values)
                lst_RecordedValues.Items.Add(Values(i).TDate & " " & Values(i).TTime & " Last record: " & Values(i).DeltaTime & " seconds before. Level=" & Values(i).Level & " PWM=" & Values(i).PWM_Level)
                lbl_LastLevel.Text = "Last Level= " & Values(i).Level
                lbl_DateTime.Text = "Time= " & Values(i).TDate & " " & Values(i).TTime
            Next
            lst_RecordedValues.SelectedIndex = lst_RecordedValues.Items.Count - 1
            lst_RecordedValues.EndUpdate()
            SaveScreenshot()
        End If

    End Sub

    Public Sub ExpandArray(Of T)(ByRef Arrayy() As T)
        If IsNothing(Arrayy) Then
            ReDim Arrayy(-1)
        End If
        ReDim Preserve Arrayy(UBound(Arrayy) + 1)
    End Sub

    Public Sub RemoveAt(Of T)(ByRef a() As T, ByVal index As Integer)
        ' Move elements after "index" down 1 position.
        System.Array.Copy(a, index + 1, a, index, UBound(a) - index)
        ' Shorten by 1 element.
        ReDim Preserve a(UBound(a) - 1)
    End Sub

    Function CorrectTo00(ByVal Without00 As String) As String
        If Len(Without00) < 2 Then
            Return "0" & Without00
        Else
            Return Without00
        End If
    End Function

    Private Sub ShowTimer_Tick(sender As System.Object, e As System.EventArgs) Handles ShowTimer.Tick
        txt_ScreenshotDirectory.Enabled = chk_SaveScreenshots.Checked
        chk_OnlyOverXLevel.Enabled = chk_SaveScreenshots.Checked
        txt_screenshotLevel.Enabled = chk_SaveScreenshots.Checked And chk_OnlyOverXLevel.Checked
    End Sub

    Sub SaveScreenshot()
        Dim Filename As String = LastDate & " " & RemoveDopplePoints(LastTime) & " Level " & LastLevel & ".jpg"
        Filename = txt_ScreenshotDirectory.Text & "\" & Filename
        If chk_SaveScreenshots.Checked = False Then Exit Sub
        If Not My.Computer.FileSystem.DirectoryExists(txt_ScreenshotDirectory.Text) Then
            My.Computer.FileSystem.CreateDirectory(txt_ScreenshotDirectory.Text)
        End If
        If chk_OnlyOverXLevel.Checked = True Then
            If Values(UBound(Values)).Level > Val(txt_screenshotLevel.Text) Then
                CreateScreenshot(WebBrowser1, Filename)
            End If
        Else
            CreateScreenshot(WebBrowser1, Filename)
        End If
    End Sub

    Private Sub CreateScreenshot(ByVal Control As Control, ByVal Filename As String)
        Dim Screenshot As New Bitmap(Control.Width, Control.Height)
        Using g As Graphics = Graphics.FromImage(Screenshot)
            g.CopyFromScreen(Control.PointToScreen(New Point(0, 0)), New Point(0, 0), New Size(Control.Width, Control.Height))
        End Using
        Screenshot.Save(Filename, System.Drawing.Imaging.ImageFormat.Jpeg)
    End Sub

    Function RemoveDopplePoints(ByVal stringg As String) As String
        Return stringg.Replace(":", "_")
    End Function

End Class
